<template>
	<div>
		<div
			v-if="!isEurope"
			class="bg-white rounded-none md:rounded-lg lg:rounded w-full lg:w-960 mx-auto px-3.5 py-6 md:px-6 lg:p-14 mb-6 md:mb-8 lg:mb-10"
		>
			<div class="mb-10 md:mb-8 lg:mb-14 flex items-center">
				<h2
					aria-label="Auto-refills"
					class="font-secondary-font-regular text-black text-xl md:text-2xl lg:text-base2 leading-6 md:leading-7 lg:leading-10"
				>
					Auto-refills
				</h2>
				<span
					tabindex="0"
					role="link"
					class="ml-3.5 lg:ml-4 cursor-pointer focus:outline-none focus:ring-1 focus:ring-black"
					@click="$router.push('/D2C/account/autoRefills/')"
					@keypress.enter="$router.push('/D2C/account/autoRefills/')"
				>
					<img src="~/assets/images/icon-right-arrow-black.svg" alt="Move to Auto-refills page" class="h-6 w-6" />
				</span>
			</div>

			<div class="w-full" role="table" aria-describedby="auto_refills">
				<div id="auto_refills" class="hidden">Auto-refills</div>
				<div
					role="row"
					class="mk-order-list-item w-full pb-6 hidden md:grid grid-cols-11 justify-between border-b border-gray-20"
				>
					<div role="columnheader" class="col-span-5">
						<span class="font-primary-font-bold text-black text-base md:text-sm lg:text-base">Device name</span>
					</div>
					<div role="columnheader" class="col-span-4">
						<span class="font-primary-font-bold text-black text-base md:text-sm lg:text-base">Device type</span>
					</div>
					<div class="col-span-2"></div>
				</div>
				<div
					v-for="subscription in subscriptionList"
					:key="subscription.id"
					role="row"
					class="mk-order-list-item w-full pt-0 py-8 mb-8 md:mb-0 md:py-6 block md:grid grid-cols-11 justify-between border-b border-gray-20"
				>
					<div role="cell" class="block md:flex items-center col-span-5 pr-0 md:pr-4">
						<div class="w-full max-w-198 md:max-w-64 mx-auto md:mx-0 md:mr-6 mb-12 md:mb-0">
							<MkProductImage
								v-if="subscription.lineItemList[0]"
								size-class="w-full"
								:product-name="subscription.lineItemList[0].name"
								:product-sku="subscription.lineItemList[0].sku"
							/>
							<!-- <img src="~/assets/images/air_pro.png" class="w-full" /> -->
						</div>
						<span class="font-primary-font-bold text-black text-base md:text-sm lg:text-base block md:hidden mb-2"
							>Device name</span
						>
						<p
							class="font-primary-font-light text-base md:text-sm lg:text-base text-black leading-6 md:leading-5 lg:leading-6 mb-6 md:mb-0 block"
						>
							{{ subscription.lineItemList[0] && subscription.lineItemList[0].name }}
						</p>
					</div>
					<div role="cell" class="mb-6 md:mb-0 block md:flex items-center col-span-4 pr-0 md:pr-4">
						<span class="font-primary-font-bold text-black text-base md:text-sm lg:text-base block md:hidden mb-2"
							>Device type</span
						>
						<span
							class="font-primary-font-light text-base md:text-sm lg:text-base text-black leading-6 md:leading-5 lg:leading-6"
							>{{ subscription.planName }}</span
						>
					</div>
					<div role="cell" class="block md:flex items-center col-span-2 justify-end">
						<MkTerritoryButton
							tabindex="0"
							role="button"
							class="min-w-150 md:min-w-90 lg:min-w-150 pt-2 pb-1.5 text-sm leading-4 mx-0"
							button-title="View"
							@click="$router.push(`/D2C/account/autoRefills/#sub_${subscription.id}`)"
							@keypress.enter="$router.push(`/D2C/account/autoRefills/#sub_${subscription.id}`)"
						/>
					</div>
				</div>
			</div>
		</div>
		<!-- recent order -->
		<div
			class="bg-white rounded-none md:rounded-lg lg:rounded w-full lg:w-960 mx-auto px-3.5 py-6 md:px-6 lg:p-14 mb-6 md:mb-8 lg:mb-10"
		>
			<div class="mb-10 md:mb-8 lg:mb-14 flex items-center">
				<h2
					aria-label="Recent orders"
					class="font-secondary-font-regular text-black text-xl md:text-2xl lg:text-base2 leading-6 md:leading-7 lg:leading-10"
				>
					Recent orders
				</h2>
				<span
					role="link"
					tabindex="0"
					class="ml-3.5 lg:ml-4 cursor-pointer focus:outline-none focus:ring-1 focus:ring-black"
					@click="$router.push('/D2C/account/order/')"
					@keypress.enter="$router.push('/D2C/account/order/')"
				>
					<img src="~/assets/images/icon-right-arrow-black.svg" alt="Move to Recent orders page" class="h-6 w-6" />
				</span>
			</div>
			<div class="w-full mk-order-list" role="table" aria-describedby="recent_order">
				<div id="recent_order" class="hidden">Recent orders</div>
				<div role="row" class="w-full pb-6 hidden md:grid grid-cols-10 justify-between border-b border-gray-20">
					<div class="col-span-2" role="columnheader">
						<span class="font-primary-font-bold text-black text-base md:text-sm lg:text-base">Order #</span>
					</div>
					<div class="col-span-2" role="columnheader">
						<span class="font-primary-font-bold text-black text-base md:text-sm lg:text-base">Date</span>
					</div>
					<div class="col-span-2" role="columnheader">
						<span class="font-primary-font-bold text-black text-base md:text-sm lg:text-base">Order total</span>
					</div>
					<div class="col-span-2"></div>
					<div class="col-span-2"></div>
				</div>
				<div
					v-for="item in orders"
					:key="item.orderId"
					role="row"
					class="font-primary-font-light mk-order-list-item w-full pt-0 mb-8 md:mb-0 pb-8 md:py-10 lg:py-6 block md:grid grid-cols-10 justify-between border-b border-gray-20"
				>
					<div role="cell" class="block md:flex items-center col-span-2 pr-0 md:pr-4 mb-2 md:mb-0">
						<span
							class="font-primary-font-bold inline-block md:hidden w-81 mr-4 text-base md:text-sm lg:text-base text-black leading-6 md:leading-5 lg:leading-6"
							>Order #</span
						>
						<span
							:class="item.trackingId ? 'font-primary-font-bold' : ''"
							class="text-base md:text-sm lg:text-base text-black leading-6 md:leading-5 lg:leading-6"
							>{{ item.orderNumber }}</span
						>
					</div>
					<div role="cell" class="mb-2 md:mb-0 block md:flex items-center col-span-2 pr-0 md:pr-4">
						<span
							class="font-primary-font-bold w-81 mr-4 inline-block md:hidden text-base md:text-sm lg:text-base text-black leading-6 md:leading-5 lg:leading-6"
							>Date</span
						>
						<span
							:class="item.trackingId ? 'font-primary-font-bold' : ''"
							class="text-base md:text-sm lg:text-base text-black leading-6 md:leading-5 lg:leading-6"
							>{{ item.orderDate | ustToDate }}</span
						>
					</div>
					<div role="cell" class="mb-4 md:mb-0 block md:flex items-center col-span-2 pr-0 md:pr-4">
						<span
							class="font-primary-font-bold inline-block md:hidden w-81 mr-4 text-base md:text-sm lg:text-base text-black leading-6 md:leading-5 lg:leading-6"
							>Order total</span
						>
						<span
							:class="item.trackingId ? 'font-primary-font-bold' : ''"
							class="text-base md:text-sm lg:text-base text-black leading-6 md:leading-5 lg:leading-6"
							>{{ currencyDisplay }}{{ item.orderTotal | centsToDollars }}</span
						>
					</div>
					<div role="cell" class="flex items-center col-span-4 justify-center md:justify-end">
						<a
							v-if="item.trackingId && !isEurope"
							:href="`http://www.fedex.com/Tracking?tracknumbers=${item.trackingId}`"
							class="flex justify-center items-center px-8 border-0 rounded-3xl border-grey-20 focus:outline-none active:outline-none font-primary-font-light focus:ring cursor-pointer mx-auto hover:bg-grey-40 bg-black text-white min-w-150 md:min-w-90 lg:min-w-150 text-sm mx-0 mr-6 ml-0 py-1.5 leading-5"
							target="_blank"
						>
							Track
						</a>
						<MkTerritoryButton
							:aria-label="'Order id ' + item.orderNumber + ' View'"
							class="min-w-150 md:min-w-90 lg:min-w-150 py-1.5 text-sm leading-5 mx-0"
							button-title="View"
							@click="$router.push(`/D2C/account/order?orderId=${item.orderId}`)"
						/>
					</div>
				</div>
			</div>
		</div>
		<div v-if="banner.url" class="w-full lg:w-960 mx-auto">
			<a :href="banner.url" target="_blank">
				<img :src="banner.image" :alt="banner.title" class="w-full" />
			</a>
		</div>
	</div>
</template>
<script>
import { mapState } from 'vuex';
import MkTerritoryButton from '~/components/D2C/atoms/MkTerritoryButton.vue';
import MkProductImage from '~/components/D2C/organisms/MkProductImage/MkProductImage.vue';
export default {
	components: {
		MkTerritoryButton,
		MkProductImage,
	},
	layout: 'aurora-layout',
	async asyncData({ store, req }) {
		return { page: await store.dispatch('pages/FETCH_PAGE_DATA', { pageName: 'account', req }) };
	},
	data() {
		return {
			orders: [],
			subscriptionList: {},
			banner: {},
		};
	},
	head() {
		return {
			title: 'Account Dashboard',
		};
	},
	computed: {
		...mapState('USER_STORE', ['DASHBOARD', 'AUTHENTICATED']),
		...mapState(['currencyDisplay', 'isEurope']),
	},
	watch: {
		AUTHENTICATED() {
			if (this.AUTHENTICATED) {
				this.getDashboard();
			}
		},
	},
	mounted() {
		if (this.AUTHENTICATED) {
			this.getDashboard();
		}
		if (this.page && this.page.shareMolekuleLink && this.page.shareMolekuleLink.url) {
			try {
				this.banner = {
					url: this.page.shareMolekuleLink.url || '',
					image: this.page.shareMolekuleBanner.url || '',
					title: this.page.shareMolekuleBanner.alt || '',
				};
			} catch (e) {}
		}
	},
	methods: {
		getFormattedDate($date) {
			return this.$options.filters.ustToDate($date);
		},
		getCentPrice($price) {
			return this.$options.filters.centsToDollars($price);
		},
		async getDashboard() {
			this.$store.commit('CHECKOUT_STORE/TOGGLE_PAGE_SPINNER');
			try {
				await this.$store.dispatch('USER_STORE/FETCH_DASHBOARD');
				if (this.DASHBOARD && this.DASHBOARD.orderSummaryResponseBean) {
					this.orders = this.DASHBOARD.orderSummaryResponseBean.results;
					// .map(this.$root.$utility.processOrderStatus).slice(0, 3)
					this.subscriptionList = this.DASHBOARD.autoRefillsResponseBean.results;
					this.$store.commit('CHECKOUT_STORE/TOGGLE_PAGE_SPINNER');
				}
			} catch (exp) {
				this.$store.commit('CHECKOUT_STORE/TOGGLE_PAGE_SPINNER');
			}
		},
	},
};
</script>
<style lang="postcss">
.mk-order-list .mk-order-list-item:last-child {
	padding-bottom: 0;
	margin-bottom: 0;
	border-bottom: 0;
}
</style>
